#ifndef __MYUSBFX__
#define __MYUSBFX__

#include <vcl.h>

// |[gRtBOp
typedef struct {
    BYTE Mode;
    BYTE Brate;
    BYTE PE;
    BYTE PD;
    BYTE PC;
    BYTE PB;
    BYTE PA;
} PCONF;

#define CNF_PIO   0
#define CNF_GPIF  1
#define CNF_FIFO  2

#define CNF_BRATE 2     // 9600bps

#define CNF_PDIR_IN   0
#define CNF_PDIR_OUT  1
#define CNF_PDIR_ADR  2

// PIORead/Writeł̃|[gZN^
#define PORTA  0
#define PORTB  1
#define PORTC  2
#define PORTD  3
#define PORTE  4
#define P_RDY  5

class TmyUsbFx ;
class TmyUsbFx
{
private:    // [U[錾

    int __fastcall WritePipe(HANDLE hUSBDriver, WORD  pipe, BYTE *buffer, int dataLen, DWORD *XfrSize);
    int __fastcall ReadPipe(HANDLE hUSBDriver , WORD pipe , BYTE *buffer, int dataLen , DWORD *XfrSize);
    int __fastcall VendorRequest( HANDLE hUSBDriver, BYTE Dir_In, BYTE recepient , BYTE bRequest,
                                WORD wValue , WORD wIndex , BYTE *buffer , int dataLen, DWORD *XfrSize );

public:     // [U[錾
    TmyUsbFx();      // RXgN^
    HANDLE hUSB;     // I[vꂽnh

    BYTE ep0dat[2];     // ]Ɏgf[^
    DWORD  xfrlen;      // x_NGXgɂ]ꂽoCg
    DWORD  status;      // x_NGXg̎擾Xe[^X

    HANDLE __fastcall OpenDriver(char *sDevname);
    int    __fastcall CloseDriver(HANDLE hUSBDriver);        // hCõN[Y
    int    __fastcall EZ_SetPortConfig(PCONF pconf) ;
    int    __fastcall EZ_WaveSet(BYTE wavenum , BYTE *wsw);
    int    __fastcall EZ_PIOWrite(BYTE Port , BYTE data );
    int    __fastcall EZ_PIORead(BYTE Port);
    int    __fastcall EZ_AdrsCTLSet(WORD Address, WORD CTL );
    int    __fastcall EZ_GPIFAbort();
    int    __fastcall EZ_GPIFTrig(BYTE EpNum, WORD XfrSize);
    int    __fastcall EZ_SglRd(WORD Address);
    int    __fastcall EZ_SglWt(WORD Address , WORD data) ;
    int    __fastcall EZ_SglWtNW(WORD Address , WORD data);

};


//  uał珳p`
// EZ-USB Driver Interface Module
#define METHOD_BUFFERED    0
#define METHOD_IN_DIRECT   1
#define METHOD_OUT_DIRECT  2

#define MAX_PIPES           16
#define MAX_USB_DEV_NUMBER  32

// Set the base of the IOCTL control codes
#define Ezusb_IOCTL_INDEX                  0x800
#define IOCTL_Ezusb_GET_PIPE_INFO          0x220000 + METHOD_BUFFERED  + (Ezusb_IOCTL_INDEX +  0) * 4
#define IOCTL_Ezusb_GET_DEVICE_DESCRIPTOR  0x220000 + METHOD_BUFFERED  + (Ezusb_IOCTL_INDEX +  1) * 4
#define IOCTL_EZUSB_BULK_READ              0x220000 + METHOD_OUT_DIRECT+ (Ezusb_IOCTL_INDEX + 19) * 4
#define IOCTL_EZUSB_BULK_WRITE             0x220000 + METHOD_IN_DIRECT + (Ezusb_IOCTL_INDEX + 20) * 4
//' x_^NXNGXgpi2003-08-10j
#define IOCTL_EZUSB_VENDOR_OR_CLASS_REQUEST 0x220000 + METHOD_IN_DIRECT + (Ezusb_IOCTL_INDEX + 22) * 4
// = = = = U S B   R e q ' d  D a t a  T y p e s = = = =
//  USB device descriptor
typedef struct {
    BYTE bDescriptorLength ;
    BYTE bDescriptor ;
    WORD iSpecRelease;
    BYTE bDeviceClass ;
    BYTE bDeviceSubClass ;
    BYTE bDeviceProtocol ;
    BYTE bMaxPacketSize ;
    WORD iVendorID ;
    WORD iProductID ;
    WORD iDeviceRelease ;
    BYTE bManufacturer ;
    BYTE bProduct ;
    BYTE bSerialNumber ;
    BYTE bNumberConfigurations ;
    BYTE fill[128];
} USBDeviceDescriptorType;

typedef struct {
    DWORD lPipeNum;
} BulkTransferControlType;

#define VRQ_SetPortConfig   0
#define VRQ_SetTimer2       1
#define VRQ_PIOWT           2
#define VRQ_PIORD           3
#define VRQ_SetWaveForm     5
#define VRQ_AbortGPIF       7
#define VRQ_GPIFSglWT       8
#define VRQ_GPIFSglRD       9
#define VRQ_GPIFTrig2    0x10
#define VRQ_GPIFTrig6    0x12

// x_NGXgp̍\
typedef struct {
    BYTE direction_in ;
    BYTE requestType ;
    BYTE recepient ;
    BYTE requestTypeReservedBits ;
    BYTE request ;
    BYTE padding_byte;
    WORD value ;
    WORD index ;
} VENDOR_OR_CLASS_REQUEST_CONTROL ;


#define hSOUT As Byte   0        //VAOUT
#define hSIN  As Byte   1        //VAIN
#define hBOUT As Byte   2        //oNOUT
#define hBIN  As Byte   3        //oNIN
#define GSTS_READY           &H0
#define GSTS_E_NODEVICE      &H1
#define GSTS_E_VERIFY        &H2
//  uał珳p`

#endif

